package org.steveshipway.blueprints;

import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedList;

import net.minecraft.world.World;


import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;

//Minecraft 1.7
import org.steveshipway.blueprints.util17.*;
//Minecraft 1.8
//import org.steveshipway.blueprints.util18.*;
//import net.minecraft.util.BlockPos;
//import net.minecraft.block.state.IBlockState;

public class Undo {
	private Hashtable steps; 
	
	public Undo() {
		this.clear();
	}
	
	public void clear() {
		this.steps = new Hashtable();
	}
	public void add(World world,BlockPos location) {
		NBTTagCompound tag = null;
		String key = location.getX()+","+location.getY()+","+location.getZ();
		if( steps.containsKey(key) ) { return; }
		IBlockState blk = Util.getBlockState(world,location);
		TileEntity te = Util.getTileEntity(world,location);
		if( te != null ) {
			tag = new NBTTagCompound();
			te.writeToNBT(tag);
		}
		steps.put(key, new UndoStep(location, blk, tag) );
	}
	public boolean rollback(World world) {
		// run .apply(world) for each step in hashset
		Iterator i;
		// apply blocks first, decorations after
		i = this.steps.values().iterator();
		while (i.hasNext()) {
		      ((UndoStep) i.next()).apply(world,0);
	    }
		i = this.steps.values().iterator();
		while (i.hasNext()) {
		      ((UndoStep) i.next()).apply(world,1);
	    }
		this.clear();
		return true;
	}
	public int size() {
		return this.steps.size();
	}
}
