package org.steveshipway.blueprints.directive;

import java.util.HashSet;

import org.apache.logging.log4j.Logger;

import net.minecraft.world.World;

// MC 1.7
import org.steveshipway.blueprints.util17.*;
// MC 1.8
//import org.steveshipway.blueprints.util18.*;
//import net.minecraft.util.BlockPos;

// null directive
// parent class for all other directives
public class Directive {
	protected boolean error = false;
	protected float auto_chance = 0;
	protected String description = null;
	protected String option = null;
	// no parameters
	
	public Directive() {
		// nothing to parse for setup
	}
	
	public boolean build(World world, BlockPos location, int r, Logger logger, HashSet softlist) {
		// nothing to do to build it
		return true;
	}
	
	public String asText() {
		return "# Null operation";
	}

	public String description() {
		return description;
	}
	public String option() {
		return option;
	}
	public float auto_chance() {
		return auto_chance;
	}
	// utility function to inherit
	public static BlockPos rotateAndAdd( BlockPos c, int r, BlockPos offset ) {
		int x, y, z;
		r = r & 3;
		y = c.getY();
		if( r == 1 ) {
			x = -c.getZ();
			z = c.getX();
		} else if( r == 2 ) {
			x = -c.getX();
			z = -c.getZ();
		} else if( r == 3 ) {
			x = c.getZ();
			z = -c.getX();
		} else {
			x = c.getX();
			z = c.getZ();
		}
		x += offset.getX();
		y += offset.getY();
		z += offset.getZ();
		BlockPos rc = new BlockPos(x,y,z);
		return rc;
	}
	
}
