package org.steveshipway.blueprints.directive;

import java.util.HashSet;

//import net.minecraft.util.BlockPos;
import net.minecraft.world.World;

import org.apache.logging.log4j.Logger;
//Minecraft 1.7
import org.steveshipway.blueprints.util17.*;
//Minecraft 1.8
//import org.steveshipway.blueprints.util18.Util;

public class IfFacingDirective extends Directive {
	private int value = 0;
	private Directive directivea = null;
	private Directive directiveb = null;
	
	public IfFacingDirective(int val, Directive da, Directive db, Logger logger) {
		this.directivea = da;
		this.directiveb = db;
		this.value = val;
		if( da == null ) {
    		logger.error("No 'if true' directive given to IFFACING directive");
			return;
		}
		if( db == null ) {
    		logger.error("No 'if false' directive given to IFFACING directive");
			return;
		}
	}
	
	@Override
	public boolean build(World world,BlockPos location, int r, Logger logger, HashSet softlist) {
		boolean rv = true;
		if( this.directivea == null || this.directiveb == null ) {
    		logger.error("Missing directive in IFFACING directive");
			return false;
		}
		if(r == this.value) {
			return this.directivea.build(world,location,r,logger,softlist);
		} else {
			return this.directiveb.build(world,location,r,logger,softlist);
		}
	}
	
	@Override
	public String asText() {
		String s = "IFFACING " + this.value + "\n  ";
		
		if( directivea == null) {
			s = s + "NOOP\n  ";
		} else {
			s = s +directivea.asText()+"\n  ";
		}
		if( directiveb == null) {
			s = s + "NOOP";
		} else {
			s = s +directiveb.asText();
		}
		return s;
	}
}
