package org.steveshipway.blueprints.directive;

import java.io.File;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.logging.log4j.Logger;

import net.minecraft.block.Block;
import net.minecraft.init.Blocks;
import net.minecraft.item.Item;
import net.minecraft.nbt.JsonToNBT;
import net.minecraft.nbt.NBTBase;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTUtil;
import net.minecraft.server.MinecraftServer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.ChatComponentText;
import net.minecraft.util.EnumFacing;
import net.minecraft.world.World;
import net.minecraft.world.chunk.Chunk;


// Minecraft 1.7
//import org.steveshipway.blueprints.util17.*;
// Minecraft 1.8
import org.steveshipway.blueprints.util18.*;

import net.minecraft.block.state.IBlockState;
import net.minecraft.util.BlockPos;

public class MsgDirective extends Directive {
	// this prints a message only
	protected String msg = null; 
	
	public MsgDirective(String msg) {
		this.msg = msg;
	}
	public MsgDirective(String definition, Logger logger) {
    	Pattern p = Pattern.compile("(?i)^(?:\\s*msg)?\\s*(.*)");
    	Matcher m = p.matcher(definition);
    	if( m.find() ) {
    		this.msg = m.group(1);
    	} else {
    		logger.error("Cannot parse MSG definition: "+definition);
    	}
	}
	
	@Override
	public boolean build(World world, BlockPos location, int r, Logger logger, HashSet softlist) {
		String message;
		message = "Build[" + location.getX()+","+location.getY()+","+location.getZ()+"]: " + this.msg;
		logger.info(message);
		// no way to reliably identify the player.  Maybe a broadcast?
		//player.addChatMessage(new ChatComponentText(this.msg));
		MinecraftServer.getServer().getConfigurationManager().sendChatMsg(new ChatComponentText(message));
		return true;
	}
	
	@Override
	public String asText() {
		String s = "MSG ";
		if( this.msg == null) {
			return "# MSG undefined ";
		}
		s += this.msg;
		return s;
	}
}
